#include <dos.h>
#include <time.h>

typedef struct {
    int x,y;
    int cenx,ceny;
    int xrange,yrange;
    int port,buttons;
    int scale;
    } joystick;

static clock_t jstart, jend;

int wcheckjoystick(void)
{
	int c, result;
	disable();
	outportb(0x201,0xff); /* Trigger joystick */
	c = inportb(0x201);
	c = inportb(0x201);
	c = inportb(0x201);
	delay(5); /* wait a few milliseconds */
	c ^= inportb(0x201); /* any bits that changed state are now set */
	enable();
	result = 0;
	if (c & 0x03) result |= 1;
	if (c & 0x0C) result |= 2;
//	return result;
	return 1;
}

int wreadjoystick(joystick *joy)
{
	int c, k, jx, jy;
	int savemask;

   window(1,1,80,25);
   jend = clock();
   if (jend-jstart>0)
   {
	if (joy->port == -1) return 0;
		outportb(0x201, 0xff); /* Trigger joystick */
		c = inportb(0x201);
		if (joy->port) c >>= 2;
		joy->buttons = ((~c) >> 4) & 0x0F;

		for (k = 0; c & 3; k++) /* Get X and Y positions */
		{
			if (c & 1) jx = k;
			if (c & 2) jy = k;
			c = inportb(0x201);
			if (joy->port) c >>= 2;
		}

	joy->x = jx - joy->cenx;
	joy->y = jy - joy->ceny;
	gotoxy(1,1);
//	if (joy->scale) {
//		joy->x = (joy->x * joy->scale) / joy->xrange;
//		joy->y = (joy->y * joy->scale) / joy->yrange;
//	}
   jstart = clock();
   }
	return 1;
}

/* This routine assumes the joystick is centered; sets the port and the
   maximum range for the joystick (i.e. minx to maxx) */

void winitjoystick(joystick *joy, int port)
{
	joy->cenx = joy->ceny = 0;
	joy->port = port; 
	joy->scale = 0;
	wreadjoystick(joy);
	joy->scale=100;
	joy->cenx = joy->x; 
	joy->ceny = joy->y;
	joy->xrange = 2*joy->x; 
	joy->yrange = 2*joy->y;
	jstart = clock();
}

void wcalibratejoystick(joystick *joy)
{
	long t;
	long maxx, maxy, minx, miny;

	maxx = maxy = 0;
	minx = miny = 10000;

	t = joy->scale;
	joy->scale = 0;
	do {
		wreadjoystick(joy);
		if (joy->x > maxx) maxx = joy->x;
		if (joy->y > maxy) maxy = joy->y;
		if (joy->x < minx) minx = joy->x;
		if (joy->y < miny) miny = joy->y;
	}
	while (joy->buttons == 0);

	joy->xrange = maxx - minx;
	joy->yrange = maxy - miny;
	delay(10);
	do {
		wreadjoystick(joy);
	}
	while (joy->buttons);
	delay(10);

	joy->scale = t;
}

