#include <dos.h>
#include <stdio.h>

// Beta test PC speaker sound driver
// March 13,1993

void wsettime(char hr,char mn,int sec);
unsigned long wgettime(void);
void wrestoretime(void);

unsigned long firstticks,lastticks;

int timerrate;
int soundnum;
int soundpos=0;
int wgtsound[500];

int inttimer=0x1C; // timer interrupt

void interrupt wgtsoundint(); /* interrupt prototype */
void interrupt (*oldint8)(); /* interrupt function pointer */

void setrate(unsigned int cycles)
{
unsigned int v;
unsigned char *t;
// changes the rate the timer tick interrupt is called
// default setting is 18.2 times/sec
// but you can change this to any number of times

   if (cycles==0)
     {
     outportb(0x43,0x36);
//     outport(0x40,v);
      outportb(0x40,0);
      outportb(0x40,0);
     }
   else {
      v=(unsigned int)(1193180/cycles); 
      outportb(0x43,0x36);
//      outport(0x40,v);
      t=&v;
      outportb(0x40,(int)*t);
      t++;
      outportb(0x40,(int)*t);
     timerrate=cycles;
     }
}

void loadsnd(int s[])
{
int num;
// load a sound into the sound array (to be played)
// Can't think of a better way to do this...

num=s[0];
for (num=0; num<=s[0]; num++)
  wgtsound[num]=s[num];
   soundpos=1;
}

void winitsnd(int rate)
// starts new rate, initializes timer
{
 if (timerrate !=rate)
  {
  firstticks=wgettime();
  oldint8  = getvect(inttimer);
  setvect(inttimer,wgtsoundint);
  setrate(rate);
  }
}

void wdeinitsnd(void)
// restores interrupt 8, resets proper time
{
soundpos=0;

setrate(0);
setvect(inttimer,oldint8);
nosound();
lastticks=wgettime();
wrestoretime();
}

/*************************************************************************
 Restores the correct time after changing the speed of the clock tick.
 It takes the tick rate, divides it by 18.2 to get the proper rate.
 Then divide the number of ticks occured since the new rate was set, by
 this value to get the number of ticks that should have occured.
 Add the previous number of ticks before rate was set, and set the
 time using this value.
 *************************************************************************/
void wrestoretime(void)    
{
unsigned long ticks;
unsigned long *t;
float hr;
float mn;
float sec;

hr=(float)timerrate/18.2065;
ticks=lastticks-firstticks;
ticks=(float)ticks/hr;
ticks+=firstticks;
hr=(float)ticks/(65543.333); 
ticks-=(long)hr*65543.333;
mn=(float)ticks/(1092.3888); 
ticks-=(long)mn*1092.3888;
sec=(float)ticks/(18.2065); 
wsettime(hr,mn,sec);
}

unsigned long wgettime(void)
// Returns the number of clock ticks since midnight
{
unsigned long ticks;
unsigned long *t;

t=MK_FP(0x000,0x046C);
return (*t);
}

void interrupt wgtsoundint()
// Sound interrupt, IRQ 8
{
disable();
if (soundpos>0)
{
soundpos++;
if (soundpos==2)
  soundnum=wgtsound[0];
else if (soundpos>1+soundnum)
   {
   soundpos=0;
   nosound();
   }
if ((wgtsound[soundpos-1]>0) & (soundpos>0))
  sound(wgtsound[soundpos-1]);
else nosound();
}
enable();

}

void wsettime(char hr,char mn,int sec)
// Dos function: Set time
{
union REGS regs;

regs.h.ah=0x2d;
regs.h.ch=hr;
regs.h.cl=mn;
regs.h.dh=sec;
regs.h.dl=0;
intdos(&regs,&regs);
}



